-- I based this GUI on the one used in the BadBoy anti-spam addon.
-- Consequently, I owe many thanks to Funkydude; permission was given to use his addon in this way.
-- Get BadBoy Anti-Spam here: https://mods.curse.com/addons/wow/bad-boy

local AddonName, AddonTable = ...
local L = AddonTable.Localize
local AddonTitle = select(2, GetAddOnInfo(AddonName))
local PlainAddonTitle = AddonTitle:gsub("|c........", ""):gsub("|r", "")

function OptionsFrame_OnLoad()
SlashCmdList["DROPTIONS"] = droptions_command
	SLASH_DROPTIONS1 = "/dr"
end

function droptions_command()
local droptions = CreateFrame("Frame", "DRConfig", UIParent)
droptions:SetSize(400, 200)
droptions:SetPoint("CENTER")
droptions:SetClampedToScreen(true)
droptions:EnableMouse(true)
droptions:SetMovable(true)
droptions:RegisterForDrag("LeftButton")
droptions:SetScript("OnDragStart", function(self) self:StartMoving() end)
droptions:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
droptions:Show()
local bg = droptions:CreateTexture()
bg:SetAllPoints(droptions)
bg:SetColorTexture(0, 0, 0, 0.5)
local close = CreateFrame("Button", nil, droptions, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", droptions, "TOPRIGHT", -5, -5)

local title = droptions:CreateFontString(nil, nil, "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText(L["DuelResponse"] .." v" .. GetAddOnMetadata("DuelResponse", "Version"))

-- Decline Duel Button

local btnDeclineDuel = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
btnDeclineDuel:SetPoint("TOPLEFT", title, "BOTTOMLEFT")

	if DRConfig.DeclineDuel == "ON" then
		btnDeclineDuel:SetChecked(true)
	elseif DRConfig.DeclineDuel == "OFF" then
		btnDeclineDuel:SetChecked(false)
	end

btnDeclineDuel:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	if tick == false then
		DRConfig.DeclineDuel = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will not be declined."])
	elseif tick == true then
		DRConfig.DeclineDuel = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Duel requests will be declined."])
	end
end)

local btnDeclineDuelText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
btnDeclineDuelText:SetPoint("LEFT", btnDeclineDuel, "RIGHT", 0, 1)
btnDeclineDuelText:SetText(L["Decline all duels"])

-- Chat Message Button

local btnShowChatMsg = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
btnShowChatMsg:SetPoint("TOPLEFT", btnDeclineDuel, "BOTTOMLEFT")

	if DRConfig.ShowChatMessage == "ON" then
		btnShowChatMsg:SetChecked(true)
	elseif DRConfig.ShowChatMessage == "OFF" then
		btnShowChatMsg:SetChecked(false)
	end

btnShowChatMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowChatMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat log messages have been turned off."])
	elseif tick == true then
		DRConfig.ShowChatMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Chat log messages have been turned on."])
	end
end)
btnShowChatMsg:SetScript("OnShow", function(frame)
	frame:SetChecked(BADBOY_OPTIONS.noAnim)
end)

local btnShowChatMsgText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
btnShowChatMsgText:SetPoint("LEFT", btnShowChatMsg, "RIGHT", 0, 1)
btnShowChatMsgText:SetText(L["Show message in chat frame when a duel is declined"])

-- Load Message Button

local btnShowLoadMsg = CreateFrame("CheckButton", nil, droptions, "OptionsBaseCheckButtonTemplate")
btnShowLoadMsg:SetPoint("TOPLEFT", btnShowChatMsg, "BOTTOMLEFT")

	if DRConfig.ShowLoadMessage == "ON" then
		btnShowLoadMsg:SetChecked(true)
	elseif DRConfig.ShowLoadMessage == "OFF" then
		btnShowLoadMsg:SetChecked(false)
	end

btnShowLoadMsg:SetScript("OnClick", function(frame)
	local tick = frame:GetChecked()
	
	if tick == false then
		DRConfig.ShowLoadMessage = 'OFF'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Load message disabled."])
	elseif tick == true then
		DRConfig.ShowLoadMessage = 'ON'
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FFFF[" .. L["DuelResponse"] .."]|r " .. L["Load message enabled."])
	end
end)
btnShowLoadMsg:SetScript("OnShow", function(frame)
	frame:SetChecked(BADBOY_OPTIONS.noAnim)
end)

local btnShowLoadMsgText = droptions:CreateFontString(nil, nil, "GameFontHighlight")
btnShowLoadMsgText:SetPoint("LEFT", btnShowLoadMsg, "RIGHT", 0, 1)
btnShowLoadMsgText:SetText(L["Show a message in chat frame on login"])

-- Stats

local statsTitle = droptions:CreateFontString("DROptionsConfigTitle", nil, "GameFontNormalLarge")
statsTitle:SetPoint("TOPLEFT", btnShowLoadMsg, "BOTTOMLEFT", 10, -65)
statsTitle:SetText(L["Total duels blocked: "] .. tonumber(GlobalDC) .. " (" ..  UnitName("player") .. ": " .. tonumber(DuelsDeclined) .. ")")

end